LeetCode63:不同路径II

代码如下

复制代码
class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        int m = obstacleGrid.size();
        int n = obstacleGrid[0].size();
        vector<vector<int> > dp(m, vector<int>(n, 0));
        for(int i = 0; i < m && obstacleGrid[i][0] == 0; i++)
        {
            dp[i][0] = 1;
        }
        for(int j = 0; j < n && obstacleGrid[0][j] == 0; j++)
        {
            dp[0][j] = 1;
        }
        for(int i = 1; i < m; i++)
        {
            for(int j = 1; j < n; j++)
            {
                if(obstacleGrid[i][j] == 1)
                    continue;
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m - 1][n - 1];
    }
};

这个题目其实也就是多加了一个条件,多了障碍物,不能走。这个时候要对初始化进行一定的判断。

我写这个题目的错误点:

(1)好长时间都没用vector这个二维数组了,我连遍历都忘了怎么遍历了。

重点写一下。

复制代码
//这个是行的多少,也就是来测量二维数组有多少行
obstacleGrid.size();
//这个是列的多少,也就是来测量二维数组有多少列
obstacleGrid[0].size();

遍历二维数组vector<vector <int> > arr(m, vector<int>(n, 0))

for(int i = 0; i < arr.size(); i++)
{
    for(int j = 0; j < arr[i].size(); j++)
    {

    }
}
这个即可,真的是糊涂!

(2)if里面的判断语句,我居然写成了dpij == 1,我感觉我的脑子真是有坑,不知道怎么想的,实际上现在想想,并不是dpij == 1,毕竟我们要求的是dpij,所以肯定是得需要原先的数obs来判断障碍物

相关推荐
奋发向前wcx1 小时前
CSP-J复赛模拟赛4 王晨旭补题 2026.10.5
算法
念何架构之路4 小时前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
晒太羊的猫5 小时前
hot100动态规划刷题
算法·动态规划
weixin_531094695 小时前
heap_4内存管理
java·开发语言·算法
余额瞒着我当琳5 小时前
红黑树的实现--红黑树的概念、规则、效率、结构、旋转、查找、验证
数据结构·c++·算法
程序员南飞5 小时前
win系统安装minio
java·数据结构·算法
青少儿编程课堂5 小时前
AC自动机多模式串匹配精讲:校园关键词巡检实战解析
c++·python·算法·bfs·信息学竞赛
我命由我123455 小时前
Photoshop - Photoshop 矢量蒙版
学习·职场和发展·产品运营·求职招聘·职场发展·产品经理·photoshop
longlongzihan6 小时前
LeetCode 5. 最长回文子串:从暴力匹配到中心扩展的思维演进
c++·算法·leetcode
waoooqwe6 小时前
问卷样本真实吗
大数据·数据库·算法·数据分析